<script>
    import { T } from "@threlte/core";

    import { useLoader } from "@threlte/core";
    import { TextureLoader } from "three";

    export let subplot;

    let texture = subplot.options_3d.earth_texture
        ? subplot.options_3d.earth_texture
        : "map_natural_earth.jpg";

    const map_texture = useLoader(TextureLoader).load(
        "textures/" + texture,
    );

    // import { useTexture } from '@threlte/extras';
    // const map_texture = useTexture('./map.png');
    // console.log(map_texture);
</script>

{#if subplot.options_3d.render_earth}
    <T.Mesh position={[0, 0, 0]} scale={[1.0, 0.99665, 1.0]}>
        <T.SphereGeometry args={[1, 64, 32]} />
        {#if $map_texture}
            <T.MeshLambertMaterial map={$map_texture} />
        {/if}
        <!-- {#await $map_texture}
            {console.log("Awaiting texture load...")}
            <T.MeshStandardMaterial/>
        {:then map_texture_value}
            {console.log("Texture loaded...")}
            <T.MeshStandardMaterial map={map_texture_value}/>
        {:catch error}
            {console.log("Error loading texture...")}
            <T.MeshStandardMaterial/>
        {/await} -->
    </T.Mesh>
{/if}
